// $Id: validation_api.js,v 1.2 2008/05/22 19:23:54 tapocol Exp $

var http_request = false;
function validation_api_submit(form) {
  var args = '';
  var eles = form.elements;
  for (var i = 0; i < eles.length; i++) {
    ele = eles[i];
    switch (ele.type) {
      case 'radio':
        if (ele.checked == true)
          args += ele.name + '='+ ele.value + '&';
      break;
      case 'checkbox':
        if (ele.checked == true)
          args += ele.name + '[' + ele.value + ']=' + ele.value + '&';
      break;
      default:
        args += ele.name +'='+ ele.value + '&';
      break;
    }
  }
  
  http_request = false;
  if (window.XMLHttpRequest) { // Mozilla, Safari,...
    http_request = new XMLHttpRequest();
    if (http_request.overrideMimeType) {
      // set type accordingly to anticipated content type
      //http_request.overrideMimeType('text/xml');
      http_request.overrideMimeType('text/html');
    }
  }
  else if (window.ActiveXObject) { // IE
    try {
      http_request = new ActiveXObject("Msxml2.XMLHTTP");
    }
    catch (e) {
      try {
        http_request = new ActiveXObject("Microsoft.XMLHTTP");
      }
      catch (e) {}
    }
  }
  if (!http_request) {
    alert('Cannot create XMLHTTP instance');
    return false;
  }
  
  http_request.onreadystatechange = function() {
    if (http_request.readyState == 4) {
      $('#' + form.id + ' .error').removeClass('error');
      var data = eval('(' + http_request.responseText + ')');
      if (data.errors != undefined) {
        var errors = data.errors;
        var message = "";
        for (var i = 0; i < errors.elements.length; i++) {
          $('#edit-' + errors.elements[i].replace(/_/, '-')).addClass('error');
          message += errors.messages[i] + "\n";
        }
        alert(message);
      }
      else {
        alert(data.message);
        document.location = "/drupal-6/?q=" + data.redirect;
      }
    }
  };
  http_request.open(form.method, '/drupal-6/?q=validate/', true);
  http_request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  http_request.setRequestHeader("Content-length", args.length);
  http_request.setRequestHeader("Connection", "close");
  http_request.send(encodeURI(args));
  
  return false;
}